﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using System.Threading.Tasks;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

        }

        private void For_Click(object sender, RoutedEventArgs e)
        {
            DateTime[] pasos = new DateTime[3];

            pasos[0] = DateTime.Now;

            int cant1 = 0;
            for (int valor = 0; valor < 100000; valor++)
            {
                if (valor < 2)
                    cant1++;
                else
                {
                    bool divisible = false;
                    for (int temp = 2; !divisible && temp < valor; temp++)
                    {
                        if (valor % temp == 0)
                            divisible = true;
                    }
                    if (!divisible)
                        cant1++;
                }
            }

            pasos[1] = DateTime.Now;

            int cant2 = 0;
            Parallel.For(0, 100000, (valor) =>
            {
                if (valor < 2)
                    cant2++;
                else
                {
                    bool divisible = false;
                    for (int temp = 2; !divisible && temp < valor; temp++)
                    {
                        if (valor % temp == 0)
                            divisible = true;
                    }
                    if (!divisible)
                        cant2++;
                }
            });

            pasos[2] = DateTime.Now;

            MessageBox.Show(
                "Con un thread: se encontraron " + cant1.ToString() + " números primos en " + pasos[1].Subtract(pasos[0]).TotalSeconds.ToString() + " segundos\n" +
                "Con múltiples threads: se encontraron " + cant2.ToString() + " números primos en " + pasos[2].Subtract(pasos[1]).TotalSeconds.ToString() + " segundos",
                "Scientia® Soluciones Informáticas",
                MessageBoxButton.OK,
                MessageBoxImage.Information);
        }

        private void ForEach_Click(object sender, RoutedEventArgs e)
        {
            DateTime[] pasos = new DateTime[3];
            int[] numeros = new int[] {
                1998697, 1998701, 1998727, 1998739, 1998761, 1998793,
                1998817, 1998827, 1998839, 1998881, 1998917, 1998923,
                1998943, 1998947, 1998949, 1998961, 1998977, 1998991,
                1999007, 1999021, 1999033, 1999043, 1999061, 1999069,
                1999099, 1999103, 1999111, 1999121, 1999163, 1999177,
                1999187, 1999211, 1999219, 1999223, 1999243, 1999247,
                1999817, 1999819, 1999853, 1999859, 1999867, 1999871,
                1999889, 1999891, 1999957, 1999969, 1999979, 1999993,
                1999273, 1999297, 1999301, 1999303, 1999307, 1999331,
                1999339, 1999343, 1999363, 1999379, 1999423, 1999441,
                1999471, 1999499, 1999511, 1999513, 1999537, 1999549,
                1999559, 1999561, 1999567, 1999603, 1999607, 1999619,
                1999631, 1999633, 1999651, 1999661, 1999667, 1999681,
                1999691, 1999703, 1999721, 1999733, 1999771, 1999799,
                1000000, 34000000, 7654321, 9876543, 76544321, 2000000000,
                1745345434, 2143945834, 1232435643, 2123432424 };

            pasos[0] = DateTime.Now;

            int cant1 = 0;
            foreach (int valor in numeros)
            {
                if (valor < 2)
                    cant1++;
                else
                {
                    bool divisible = false;
                    for (int temp = 2; !divisible && temp < valor; temp++)
                    {
                        if (valor % temp == 0)
                            divisible = true;
                    }
                    if (!divisible)
                        cant1++;
                }
            }

            pasos[1] = DateTime.Now;

            int cant2 = 0;
            Parallel.ForEach(numeros, (valor) =>
            {
                if (valor < 2)
                    cant2++;
                else
                {
                    bool divisible = false;
                    for (int temp = 2; !divisible && temp < valor; temp++)
                    {
                        if (valor % temp == 0)
                            divisible = true;
                    }
                    if (!divisible)
                        cant2++;
                }
            });

            pasos[2] = DateTime.Now;

            MessageBox.Show(
                "Con un thread: se encontraron " + cant1.ToString() + " números primos en " + pasos[1].Subtract(pasos[0]).TotalSeconds.ToString() + " segundos\n" +
                "Con múltiples threads: se encontraron " + cant2.ToString() + " números primos en " + pasos[2].Subtract(pasos[1]).TotalSeconds.ToString() + " segundos",
                "Scientia® Soluciones Informáticas",
                MessageBoxButton.OK,
                MessageBoxImage.Information);
        }

        private void WaitAll_Click(object sender, RoutedEventArgs e)
        {
            DateTime[] pasos = new DateTime[3];

            pasos[0] = DateTime.Now;

            EsperarXMilisegundos(1000);
            EsperarXMilisegundos(1000);
            EsperarXMilisegundos(1000);

            pasos[1] = DateTime.Now;

            //Creo los objetos Task
            Task[] tareas = new Task[] {
                new Task(EsperarXMilisegundos, 1000),
                new Task(EsperarXMilisegundos, 1000),
                new Task(EsperarXMilisegundos, 1000)};

            //Inicio las tareas
            tareas[0].Start();
            tareas[1].Start();
            tareas[2].Start();

            //Espero que se ejecuten
            Task.WaitAll(tareas);

            pasos[2] = DateTime.Now;

            MessageBox.Show(
                "Con un thread: " + pasos[1].Subtract(pasos[0]).TotalSeconds.ToString() + " segundos\n" +
                "Con múltiples threads: " + pasos[2].Subtract(pasos[1]).TotalSeconds.ToString() + " segundos",
                "Scientia® Soluciones Informáticas",
                MessageBoxButton.OK,
                MessageBoxImage.Information);
        }

        /// <summary>
        /// Método que solamente espera el tiempo
        /// especificado por parámetro
        /// </summary>
        private void EsperarXMilisegundos(object milisegundos)
        {
            Thread.Sleep((int)milisegundos);
        }

        private void ContinueWith_Click(object sender, RoutedEventArgs e)
        {
            //Creo la tarea para que utilice el método "Rutina"
            Task Tarea = new Task(Rutina);

            //Especifico que rutina ejecutar en caso de generarse una excepción
            Task TareaConError = Tarea.ContinueWith(CorreccionError, TaskContinuationOptions.OnlyOnFaulted);

            //Especifico que rutina ejecutar al finalizar la tarea
            Task TareaFinalizar = Tarea.ContinueWith(Finalizar, TaskContinuationOptions.OnlyOnRanToCompletion);
            Task TareaFinalizar2 = TareaConError.ContinueWith(Finalizar);

            //Inicio la tarea
            Tarea.Start();
        }

        private void Rutina()
        {
            MessageBox.Show("Rutina inicial");
            throw new Exception("Excepción generada de ejemplo");
        }

        private void CorreccionError(Task TareaPrevia)
        {
            MessageBox.Show("Excepción: " + TareaPrevia.Exception.Message);
        }

        private void Finalizar(Task TareaPrevia)
        {
            MessageBox.Show("Rutina Finalizar");
        }

        private void For_lock_Click(object sender, RoutedEventArgs e)
        {
            DateTime[] pasos = new DateTime[3];

            pasos[0] = DateTime.Now;

            int cant1 = 0;
            Parallel.For(0, 100000, (valor) =>
            {
                if (valor < 2)
                    cant1++;
                else
                {
                    bool divisible = false;
                    for (int temp = 2; !divisible && temp < valor; temp++)
                    {
                        if (valor % temp == 0)
                            divisible = true;
                    }
                    if (!divisible)
                        cant1++;
                }
            });

            pasos[1] = DateTime.Now;

            int cant2 = 0;
            object bloqueo = new object();
            Parallel.For(0, 100000, (valor) =>
            {
                if (valor < 2)
                    lock (bloqueo)
                        cant2++;
                else
                {
                    bool divisible = false;
                    for (int temp = 2; !divisible && temp < valor; temp++)
                    {
                        if (valor % temp == 0)
                            divisible = true;
                    }
                    if (!divisible)
                        lock (bloqueo)
                            cant2++;
                }
            });

            pasos[2] = DateTime.Now;

            MessageBox.Show(
                "Con múltiples threads sin bloqueo: se encontraron " + cant1.ToString() + " números primos en " + pasos[1].Subtract(pasos[0]).TotalSeconds.ToString() + " segundos\n" +
                "Con múltiples threads con bloqueo: se encontraron " + cant2.ToString() + " números primos en " + pasos[2].Subtract(pasos[1]).TotalSeconds.ToString() + " segundos",
                "Scientia® Soluciones Informáticas",
                MessageBoxButton.OK,
                MessageBoxImage.Information);
        }

        private void For_Interlocked_Click(object sender, RoutedEventArgs e)
        {
            DateTime[] pasos = new DateTime[3];

            pasos[0] = DateTime.Now;

            int cant1 = 0;
            Parallel.For(0, 100000, (valor) =>
            {
                if (valor < 2)
                    cant1++;
                else
                {
                    bool divisible = false;
                    for (int temp = 2; !divisible && temp < valor; temp++)
                    {
                        if (valor % temp == 0)
                            divisible = true;
                    }
                    if (!divisible)
                        cant1++;
                }
            });

            pasos[1] = DateTime.Now;

            int cant2 = 0;
            Parallel.For(0, 100000, (valor) =>
            {
                if (valor < 2)
                    Interlocked.Increment(ref cant2);
                else
                {
                    bool divisible = false;
                    for (int temp = 2; !divisible && temp < valor; temp++)
                    {
                        if (valor % temp == 0)
                            divisible = true;
                    }
                    if (!divisible)
                        Interlocked.Increment(ref cant2);
                }
            });

            pasos[2] = DateTime.Now;

            MessageBox.Show(
                "Con múltiples threads sin bloqueo: se encontraron " + cant1.ToString() + " números primos en " + pasos[1].Subtract(pasos[0]).TotalSeconds.ToString() + " segundos\n" +
                "Con múltiples threads con bloqueo: se encontraron " + cant2.ToString() + " números primos en " + pasos[2].Subtract(pasos[1]).TotalSeconds.ToString() + " segundos",
                "Scientia® Soluciones Informáticas",
                MessageBoxButton.OK,
                MessageBoxImage.Information);
        }
        
    }
}